; Routines needed in the first part, running the analysis
.compile auxiliary/overlay
.compile bckfourier
.compile zeropad
.compile scaleconvolve
.compile waveletanalysis

; Routines needed to plot the results
.compile auxiliary/overlay
.compile auxiliary/overcontour
.compile auxiliary/numplot
.compile getdegree
.compile plotspectra

; Definition of map to be analysed: filename="namebase+".fits"
namebase='test512_9'

; read map and list of scales
map=readfits(namebase+".fits",hdr)
; The scale grid is very rough here for demonstration,
; a finer one should be used for real analysis
readcol, "scales_rough.dat", numi, scales

; inspect the map in color - not required for analysis
overlay, map
device, bypass_translation=0
loadct, 39
!p.charsize=1.5
overlay, map
; make sure that invalid points in the map are set to !values.f_nan

; Analysis - demonstrating all three types of edge treatment
aspect=sqrt(2.0) ; b parameter
; periodic
type='NA'
resfeld=waveletanalysis(map,scales,aspect=aspect,edgetaper=-1,/progress)
writefits, namebase+"_allconvolved_"+type+".fits", resfeld
; non-periodic, no edge tapering
type="QA"
resfeld=waveletanalysis(map,scales,aspect=aspect,edgetaper=0,/progress)
writefits, namebase+"_allconvolved_"+type+".fits", resfeld
; non-periodic, with edge tapering, write out tapered field
type="TA"
resfeld=waveletanalysis(map,scales,aspect=aspect,edgetaper=0.1,taperedmap=tmap,/progress)
writefits, namebase+"_tapered.fits", tmap
writefits, namebase+"_allconvolved_"+type+".fits", resfeld


; Examine the results - last type of edge treatment as an example
plotspectra, namebase, type, scales='scales_rough.dat', /scaled
plotdegrees, namebase, type, scales='scales_rough.dat'
angularhist, namebase, type, scales='scales_rough.dat'

; Look at the distribution of wavelet coefficients
resfeld=readfits(namebase+"_allconvolved_"+type+".fits")
; Select one scale - example: 4th out of 6 scales
i=3
print, "Scale: ",scales[i]
overlay, resfeld[*,*,0,i] ; shows the isotropic wavelet coefficients
overlay, resfeld[*,*,1,i] ; shows the anisotropic wavelet coefficients
; identify bright structures
mask=resfeld[*,*,0,i]*0.0+1.0
mask[where(resfeld[*,*,0,i] lt max(resfeld[*,*,0,i]*0.01))]=!values.f_nan
overlay, resfeld[*,*,2,i]*mask; shows angles for significant bright structures

